"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _dataloader = _interopRequireDefault(require("./dataloader"));

var _assertWrap = _interopRequireDefault(require("./assertWrap"));

var _mongodb = require("mongodb");

var _graphqlSubscriptions = require("graphql-subscriptions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class Option {
  constructor(db) {
    _defineProperty(this, "callback", () => {
      for (let i = 0; i < 3; i++) {
        const type = this.typeDefs[i];
        const length = this.typeInitLength[i];

        if (type.length === length) {
          this.typeDefs = this.typeDefs.filter((_, index) => index !== i);
          delete this.resolvers[this._map[i]];
        }
      }

      return this;
    });

    _defineProperty(this, "mongo", {});

    _defineProperty(this, "loader", {});

    _defineProperty(this, "resolvers", {
      Query: {},
      Mutation: {},
      Subscription: {}
    });

    _defineProperty(this, "typeDefs", [`
    type Query {
    }
  `, `
    type Mutation {
    }
  `, `
    type Subscription {
    }
  `]);

    _defineProperty(this, "typeInitLength", this.typeDefs.map(i => i.length));

    _defineProperty(this, "use", modules => {
      Array.isArray(modules) ? modules.forEach(this._useModule) : this._useModule(modules);
      return this;
    });

    _defineProperty(this, "_map", ['Query', 'Mutation', 'Subscription']);

    _defineProperty(this, "_merge", ([type, resolver], name, index) => {
      const kind = this._map[index];
      this.typeDefs[index] = this.typeDefs[index].replace(/{/, `{
         ${type.replace(/^ {2}/gm, name)}
      `);

      if (kind === 'Subscription') {
        for (let i in resolver) {
          const t = resolver[i];

          const a = (_, __, {
            pubsub
          }) => pubsub.asyncIterator(i);

          resolver[i] = typeof t === 'function' ? {
            resolve: t,
            subscribe: a
          } : {
            resolve: t[0],
            subscribe: (0, _graphqlSubscriptions.withFilter)(a, t[1])
          };
        }
      } else {
        // Query, Mutation
        for (let i in resolver) {
          resolver[i] = (0, _assertWrap.default)(resolver[i]);
        }
      }

      Object.assign(this.resolvers[kind], resolver);
    });

    _defineProperty(this, "_mergeType", ([type, resolver]) => {
      type && this.typeDefs.push(type);
      resolver && Object.assign(this.resolvers, resolver);
    });

    _defineProperty(this, "_sort", (keys, results, field) => field === '_id' ? keys.map(id => results.find(i => i._id.equals(id))) : keys.map(key => results.find(i => i[field] === key)));

    _defineProperty(this, "_useModule", module => {
      if (Array.isArray(module)) return this.use(module);
      const type = module.type,
            query = module.query,
            mutation = module.mutation,
            subscription = module.subscription,
            name = module.name,
            loader = module.loader,
            mq = module.mq,
            collection = module.collection;
      type && this._mergeType(type);
      query && this._merge(query, name, 0);
      mutation && this._merge(mutation, name, 1);
      subscription && this._merge(subscription, name, 2);
      collection && (this.mongo[collection] = this.db.collection(collection));
      loader && (this.loader[name] = new _dataloader.default(async args => {
        if (loader === '_id') {
          args = args.map(_mongodb.ObjectId);
        }

        const res = await this.mongo[name].find({
          [loader]: {
            $in: args
          }
        }, {
          limit: args.length
        }).toArray();
        return this._sort(args, res, loader);
      }));

      if (mq) {
        const _require = require('ovis-mq'),
              subscribe = _require.subscribe;

        for (let i in mq) {
          subscribe(i, mq[i]);
        }
      }
    });

    this.db = db;
  }

}

exports.default = Option;

_defineProperty(Option, "createDb", async dbName => {
  const client = await _mongodb.MongoClient.connect(process.env.DB || `mongodb://localhost:27017/${dbName}`, {
    useNewUrlParser: true
  });
  return client.db();
});